# Module repository

This folder contains a collection of modules maintained by the developer(s) of TreeViewer. All the modules are signed and tested before being included in this repository.

The modules can be loaded or installed by using the `Load from repository...` or `Install from repository...` options in the module manager window.
Alternatively, the module `json.zip` files can be downloaded and loaded or installed manually using the `Load...` or `Install...` options.

Click on the name of any module to open the folder containing the module's manual and `json.zip` file.

## List of currently available modules

<br />

### [Add attribute](afb64d72-971d-4780-8dbb-a7d9248da30b)

_Version 1.0.1, by Giorgio Bianchini_

**Description**: Adds or changes the value of an attribute of a node.

**Module type**: FurtherTransformation

**Module ID**: `afb64d72-971d-4780-8dbb-a7d9248da30b`

<br />

### [Add attribute](f71a5e60-5e40-4a5e-9795-e5259fb283ab)

_Version 1.1.2, by Giorgio Bianchini_

**Description**: Adds an attribute based on an attachment.

**Module type**: FurtherTransformation

**Module ID**: `f71a5e60-5e40-4a5e-9795-e5259fb283ab`

<br />

### [Add index](d46f9715-7453-4d3a-a498-caf69e7808bc)

_Version 1.0.0, by Giorgio Bianchini_

**Description**: Adds the index of each leaf as an attribute on the tree.

**Module type**: FurtherTransformation

**Module ID**: `d46f9715-7453-4d3a-a498-caf69e7808bc`

<br />

### [Open file (advanced)](98804064-922f-4395-8a96-216d4b3ff259)

_Version 1.0.0, by Giorgio Bianchini_

**Description**: Opens a tree file, specifying which modules should be used for the reading and loading of the file.

**Module type**: MenuAction

**Module ID**: `98804064-922f-4395-8a96-216d4b3ff259`

<br />

### [Age distributions timeline](b93f8a2b-8731-4658-92f5-bb80af7292a8)

_Version 1.1.0, by Giorgio Bianchini_

**Description**: Plots age distributions on a timeline.

**Module type**: Plotting

**Module ID**: `b93f8a2b-8731-4658-92f5-bb80af7292a8`

<br />

### [Apply crop](6856e046-3553-465a-8b35-c351428120db)

_Version 1.0.0, by Giorgio Bianchini_

**Description**: Adds a crop region including the current view or the selected node.

**Module type**: MenuAction

**Module ID**: `6856e046-3553-465a-8b35-c351428120db`

<br />

### [Apply Further transformations](9b49587c-3d02-4fbe-859f-feed56dca92d)

_Version 1.0.1, by Giorgio Bianchini_

**Description**: Applies the actions performed by the Further transformation modules.

**Module type**: MenuAction

**Module ID**: `9b49587c-3d02-4fbe-859f-feed56dca92d`

<br />

### [Apply modules to other tree](bb4eb8d4-1925-4f08-8881-c8dd6531e5c4)

_Version 1.1.0, by Giorgio Bianchini_

**Description**: Applies the modules that are currently enabled to another tree.

**Module type**: MenuAction

**Module ID**: `bb4eb8d4-1925-4f08-8881-c8dd6531e5c4`

<br />

### [Apply modules to other tree (command-line)](7476c9e4-05b1-4a92-8d36-aa878d22cceb)

_Version 1.0.0, by Giorgio Bianchini_

**Description**: Applies the modules that are currently enabled to another tree.

**Module type**: Action

**Module ID**: `7476c9e4-05b1-4a92-8d36-aa878d22cceb`

<br />

### [Apply Transformer action](cdd01933-9e17-438a-ae45-57178e3d30cd)

_Version 1.0.1, by Giorgio Bianchini_

**Description**: Applies the action performed by the Transformer module.

**Module type**: MenuAction

**Module ID**: `cdd01933-9e17-438a-ae45-57178e3d30cd`

<br />

### [Binary tree](8ccec519-3d83-4617-824f-dd474c88bdea)

_Version 1.0.0, by Giorgio Bianchini_

**Description**: Opens a file containing one or more trees in binary format.
Safe even when opening huge files.

**Module type**: FileType

**Module ID**: `8ccec519-3d83-4617-824f-dd474c88bdea`

<br />

### [Branches](7c767b07-71be-48b2-8753-b27f3e973570)

_Version 1.1.0, by Giorgio Bianchini_

**Description**: Plots tree branches as lines.

**Module type**: Plotting

**Module ID**: `7c767b07-71be-48b2-8753-b27f3e973570`

<br />

### [Branch extensions](fb385719-b376-49b0-8e99-aab7cf641966)

_Version 1.0.3, by Giorgio Bianchini_

**Description**: Extends terminal branches.

**Module type**: Plotting

**Module ID**: `fb385719-b376-49b0-8e99-aab7cf641966`

<br />

### [Branch score style](10bbbbe1-c634-4582-9073-11f067a54081)

_Version 1.1.2, by Giorgio Bianchini_

**Description**: Sets the plot actions to display node scores using the branch colours.

**Module type**: Action

**Module ID**: `10bbbbe1-c634-4582-9073-11f067a54081`

<br />

### [Cartoon node](0c3400fd-8872-4395-83bc-a5dc5f4967fe)

_Version 1.0.0, by Giorgio Bianchini_

**Description**: Marks a node to be displayed as a "cartoon".

**Module type**: FurtherTransformation

**Module ID**: `0c3400fd-8872-4395-83bc-a5dc5f4967fe`

<br />

### [Cartoon selection](6c340923-e3d1-4646-a673-6b542a05275b)

_Version 1.0.2, by Giorgio Bianchini_

**Description**: Marks the selected node to be displayed as a "cartoon".

**Module type**: SelectionAction

**Module ID**: `6c340923-e3d1-4646-a673-6b542a05275b`

<br />

### [Change attribute](8de06406-68e4-4bd8-97eb-2185a0dd1127)

_Version 1.0.1, by Giorgio Bianchini_

**Description**: Changes the value of an already existing attribute.

**Module type**: FurtherTransformation

**Module ID**: `8de06406-68e4-4bd8-97eb-2185a0dd1127`

<br />

### [Circular](92aac276-3af7-4506-a263-7220e0df5797)

_Version 1.0.0, by Giorgio Bianchini_

**Description**: Computes the coordinates for a circular tree.

**Module type**: Coordinate

**Module ID**: `92aac276-3af7-4506-a263-7220e0df5797`

<br />

### [Circular tree style](1f3e0b88-c42d-417c-ba14-ba228be086a7)

_Version 1.0.3, by Giorgio Bianchini_

**Description**: Sets the plot actions to display the tree as a circular tree.

**Module type**: Action

**Module ID**: `1f3e0b88-c42d-417c-ba14-ba228be086a7`

<br />

### [Collapse node](3812314b-e821-4399-abfd-2a929a7a7d80)

_Version 1.0.0, by Giorgio Bianchini_

**Description**: Collapses a node.

**Module type**: FurtherTransformation

**Module ID**: `3812314b-e821-4399-abfd-2a929a7a7d80`

<br />

### [Collapse selection](e149aeb6-a019-41e2-8830-e4dc3e0eee43)

_Version 1.0.2, by Giorgio Bianchini_

**Description**: Collapses the selected node.

**Module type**: SelectionAction

**Module ID**: `e149aeb6-a019-41e2-8830-e4dc3e0eee43`

<br />

### [Color picker](5c99fbfb-a6c6-4e07-915d-670b07d255c8)

_Version 1.0.1, by Giorgio Bianchini_

**Description**: Opens a color picker window.

**Module type**: MenuAction

**Module ID**: `5c99fbfb-a6c6-4e07-915d-670b07d255c8`

<br />

### [Compare trees](36ca9f8c-25b2-4b2b-aa16-308227788e5d)

_Version 1.0.0, by Giorgio Bianchini_

**Description**: Compares a tree with another tree loaded as an attachment or from the loaded trees.

**Module type**: FurtherTransformation

**Module ID**: `36ca9f8c-25b2-4b2b-aa16-308227788e5d`

<br />

### [Compressed memory loader](3174e194-24a5-46f9-9836-b706cf0be326)

_Version 1.0.1, by Giorgio Bianchini_

**Description**: Loads the tree in memory in a compressed format.
Safe even when using large files.

**Module type**: LoadFile

**Module ID**: `3174e194-24a5-46f9-9836-b706cf0be326`

<br />

### [Compute node ages](70ea5221-9faf-4792-b428-5fee9aa1a001)

_Version 1.0.0, by Giorgio Bianchini_

**Description**: Computes node ages.

**Module type**: FurtherTransformation

**Module ID**: `70ea5221-9faf-4792-b428-5fee9aa1a001`

<br />

### [Consensus](32914d41-b182-461e-b7c6-5f0263cc1ccd)

_Version 1.0.1, by Giorgio Bianchini_

**Description**: Computes the consensus of multiple trees (or returns one of them).

**Module type**: Transformer

**Module ID**: `32914d41-b182-461e-b7c6-5f0263cc1ccd`

<br />

### [Copy selected node](debd9130-8451-4413-88f0-6357ec817021)

_Version 1.0.2, by Giorgio Bianchini_

**Description**: Copies the selected node to the clipboard.

**Module type**: SelectionAction

**Module ID**: `debd9130-8451-4413-88f0-6357ec817021`

<br />

### [Copy selected node](650a0ef5-5322-4511-ae86-68bd87b47ecd)

_Version 1.0.0, by Giorgio Bianchini_

**Description**: Copies the selected node to the clipboard.

**Module type**: MenuAction

**Module ID**: `650a0ef5-5322-4511-ae86-68bd87b47ecd`

<br />

### [Crop region](5a8eb0c8-7139-4583-9e9e-375749a98973)

_Version 1.0.0, by Giorgio Bianchini_

**Description**: Specifies a region of the plot to be cropped.

**Module type**: Plotting

**Module ID**: `5a8eb0c8-7139-4583-9e9e-375749a98973`

<br />

### [Custom action script](91b732fc-289b-4a91-84ef-b9ee3a89c86b)

_Version 1.0.0, by Giorgio Bianchini_

**Description**: Executes custom code.

**Module type**: Action

**Module ID**: `91b732fc-289b-4a91-84ef-b9ee3a89c86b`

<br />

### [Custom script](a76d00d2-95e0-4274-a77d-1439a013e3d9)

_Version 1.1.0, by Giorgio Bianchini_

**Description**: Executes custom code.

**Module type**: FurtherTransformation

**Module ID**: `a76d00d2-95e0-4274-a77d-1439a013e3d9`

<br />

### [Custom script](cdb74bfb-8a90-48b3-815a-8f908d2a1ff5)

_Version 1.0.1, by Giorgio Bianchini_

**Description**: Executes custom code.

**Module type**: Plotting

**Module ID**: `cdb74bfb-8a90-48b3-815a-8f908d2a1ff5`

<br />

### [Disk loader](71727eb5-550d-435e-8e9b-37606d3b0a4e)

_Version 1.0.1, by Giorgio Bianchini_

**Description**: Lazily accesses the trees from disk.
Safe even when using huge files.
If the input file is not in binary tree format, it will be converted to a temporary file.

**Module type**: LoadFile

**Module ID**: `71727eb5-550d-435e-8e9b-37606d3b0a4e`

<br />

### [Draw image](a26abc43-1b12-40c9-9e23-bd3de2718829)

_Version 1.0.1, by Giorgio Bianchini_

**Description**: Draws an image.

**Module type**: Plotting

**Module ID**: `a26abc43-1b12-40c9-9e23-bd3de2718829`

<br />

### [Export](d5d75840-4a71-4b81-bfc4-431736792abb)

_Version 1.1.0, by Giorgio Bianchini_

**Description**: Exports the tree plot as a PDF, SVG or PNG image.

**Module type**: MenuAction

**Module ID**: `d5d75840-4a71-4b81-bfc4-431736792abb`

<br />

### [Feedback & questions](f10d9b5b-a9ff-4036-90d5-23f73042fec5)

_Version 1.0.0, by Giorgio Bianchini_

**Description**: Opens a web browser at the TreeViewer feedback/questions page.

**Module type**: MenuAction

**Module ID**: `f10d9b5b-a9ff-4036-90d5-23f73042fec5`

<br />

### [Group labels](7ef15916-4383-4ee7-b4bd-bd44a7be1849)

_Version 1.2.2, by Giorgio Bianchini_

**Description**: Highlights monophyletic groups with a label.

**Module type**: Plotting

**Module ID**: `7ef15916-4383-4ee7-b4bd-bd44a7be1849`

<br />

### [Highlights](28e76a57-6930-4c49-974c-639c104dc4ba)

_Version 1.0.0, by Giorgio Bianchini_

**Description**: Highlights multiple nodes in a tree based on attribute values.

**Module type**: Plotting

**Module ID**: `28e76a57-6930-4c49-974c-639c104dc4ba`

<br />

### [Highlight node](64769664-d163-4fce-b7ba-18fd9445fcfb)

_Version 1.0.0, by Giorgio Bianchini_

**Description**: Highlights a single node in the tree.

**Module type**: Plotting

**Module ID**: `64769664-d163-4fce-b7ba-18fd9445fcfb`

<br />

### [Highlight selection](5bf2292f-cff3-4aa8-9c15-e881d426cba6)

_Version 1.0.1, by Giorgio Bianchini_

**Description**: Highlights the selected node in the plot.

**Module type**: SelectionAction

**Module ID**: `5bf2292f-cff3-4aa8-9c15-e881d426cba6`

<br />

### [Labels](ac496677-2650-4d92-8646-0812918bab03)

_Version 1.3.0, by Giorgio Bianchini_

**Description**: Draws labels on nodes, tips or branches.

**Module type**: Plotting

**Module ID**: `ac496677-2650-4d92-8646-0812918bab03`

<br />

### [Lasso selection](a04dcde8-75e2-43b5-a45b-e78ec8fd1ab6)

_Version 1.1.2, by Giorgio Bianchini_

**Description**: Selects tips from the tree.

**Module type**: Action

**Module ID**: `a04dcde8-75e2-43b5-a45b-e78ec8fd1ab6`

<br />

### [Lasso selection (menu action)](b4411c95-e615-4fa9-80c1-d01c84cf8a54)

_Version 1.0.0, by Giorgio Bianchini_

**Description**: Selects tips from the tree.

**Module type**: MenuAction

**Module ID**: `b4411c95-e615-4fa9-80c1-d01c84cf8a54`

<br />

### [Legend](06888353-e930-4d08-ab24-5727bced8cd6)

_Version 1.0.0, by Giorgio Bianchini_

**Description**: Draws a Markdown legend.

**Module type**: Plotting

**Module ID**: `06888353-e930-4d08-ab24-5727bced8cd6`

<br />

### [Linear transformation](50a98b43-6e92-4499-a81e-4f9609b47e7b)

_Version 1.0.0, by Giorgio Bianchini_

**Description**: Applies a linear transformation to a numeric attribute.

**Module type**: FurtherTransformation

**Module ID**: `50a98b43-6e92-4499-a81e-4f9609b47e7b`

<br />

### [Memory loader](a22ff194-c486-4215-a4bf-7a006d6f88fa)

_Version 1.0.2, by Giorgio Bianchini_

**Description**: Loads all the trees from the file into memory.
Huge files may cause the program to run out of memory.

**Module type**: LoadFile

**Module ID**: `a22ff194-c486-4215-a4bf-7a006d6f88fa`

<br />

### [NCBI ASN.1](27d3b548-0bfe-4c8d-99f6-e8111a20f019)

_Version 1.0.0, by Giorgio Bianchini_

**Description**: Opens a file containing a tree in the NCBI ASN.1 text and binary format.

**Module type**: FileType

**Module ID**: `27d3b548-0bfe-4c8d-99f6-e8111a20f019`

<br />

### [Newick](79dfb9b2-ff10-4ed9-aa74-f7b3ae93c3d2)

_Version 1.0.0, by Giorgio Bianchini_

**Description**: Opens a file containing one or more trees in the Newick (-with-attributes) format.
Safe even when opening huge files.

**Module type**: FileType

**Module ID**: `79dfb9b2-ff10-4ed9-aa74-f7b3ae93c3d2`

<br />

### [New tree](36a54db0-4e24-4786-8b84-ad4e188c3285)

_Version 1.0.0, by Giorgio Bianchini_

**Description**: Creates a new random tree or builds a tree from a sequence alignment.

**Module type**: MenuAction

**Module ID**: `36a54db0-4e24-4786-8b84-ad4e188c3285`

<br />

### [NEXUS](31fdfc2f-1921-432e-bb47-51362dd4fabb)

_Version 1.0.0, by Giorgio Bianchini_

**Description**: Opens a file in the NEXUS format, reading the trees in the "Trees" blocks and the module information in the "TreeViewer" blocks.
Safe even when opening huge files.

**Module type**: FileType

**Module ID**: `31fdfc2f-1921-432e-bb47-51362dd4fabb`

<br />

### [Node bars](319e8f63-d6c9-4dac-9419-0b621dcd5f23)

_Version 1.0.2, by Giorgio Bianchini_

**Description**: Draws node bars.

**Module type**: Plotting

**Module ID**: `319e8f63-d6c9-4dac-9419-0b621dcd5f23`

<br />

### [Node shapes](7434420a-1afd-46ee-aeea-75ed8a5eeada)

_Version 1.0.4, by Giorgio Bianchini_

**Description**: Draws shapes on nodes, tips or branches.

**Module type**: Plotting

**Module ID**: `7434420a-1afd-46ee-aeea-75ed8a5eeada`

<br />

### [Node states](0512b822-044d-4c13-b3bb-bca494c51daa)

_Version 1.2.5, by Giorgio Bianchini_

**Description**: Draws node states based on attributes.

**Module type**: Plotting

**Module ID**: `0512b822-044d-4c13-b3bb-bca494c51daa`

<br />

### [Online manual](bc943abb-66d9-4425-be78-6ff7fb4148f0)

_Version 1.0.1, by Giorgio Bianchini_

**Description**: Opens a web browser window at the TreeViewer manual homepage.

**Module type**: MenuAction

**Module ID**: `bc943abb-66d9-4425-be78-6ff7fb4148f0`

<br />

### [Open file](078318bc-907f-4ada-b1e5-171799957b2a)

_Version 1.0.0, by Giorgio Bianchini_

**Description**: Opens a tree file.

**Module type**: MenuAction

**Module ID**: `078318bc-907f-4ada-b1e5-171799957b2a`

<br />

### [Parse age distributions](15c955ce-bd4c-4a96-8cd3-b48d37aafc4c)

_Version 1.0.0, by Giorgio Bianchini_

**Description**: Parses node age distributions from node attributes.

**Module type**: FurtherTransformation

**Module ID**: `15c955ce-bd4c-4a96-8cd3-b48d37aafc4c`

<br />

### [Parse node states](716b55a3-02d9-4007-a830-8326d407b24c)

_Version 2.1.3, by Giorgio Bianchini_

**Description**: Loads node state data from an attachment.

**Module type**: FurtherTransformation

**Module ID**: `716b55a3-02d9-4007-a830-8326d407b24c`

<br />

### [Paste tree](a916ad8e-2f22-439f-b764-8beb54673f7d)

_Version 1.0.1, by Giorgio Bianchini_

**Description**: Loads a tree from the clipboard.

**Module type**: MenuAction

**Module ID**: `a916ad8e-2f22-439f-b764-8beb54673f7d`

<br />

### [Age distributions](5dbe1f3c-dbea-49b3-8f04-f319aefca534)

_Version 1.2.0, by Giorgio Bianchini_

**Description**: Plots node age distributions.

**Module type**: Plotting

**Module ID**: `5dbe1f3c-dbea-49b3-8f04-f319aefca534`

<br />

### [Plot alignment](ea7e246b-e93f-4d0d-a67a-88af05479b48)

_Version 1.0.2, by Giorgio Bianchini_

**Description**: Adds the plot of an alignment to the tree.

**Module type**: Plotting

**Module ID**: `ea7e246b-e93f-4d0d-a67a-88af05479b48`

<br />

### [Polytomise node](19d9a555-07e6-4dac-afc1-d5ffcef35f76)

_Version 1.0.1, by Giorgio Bianchini_

**Description**: Transforms nodes into politomies.

**Module type**: FurtherTransformation

**Module ID**: `19d9a555-07e6-4dac-afc1-d5ffcef35f76`

<br />

### [Polytomise selection](8202afa4-c9a6-47ac-98d5-dd0190c23f63)

_Version 1.1.2, by Giorgio Bianchini_

**Description**: Transforms the selected node into a polytomy.

**Module type**: SelectionAction

**Module ID**: `8202afa4-c9a6-47ac-98d5-dd0190c23f63`

<br />

### [Propagate attribute](85eee26d-29b6-4470-8184-f42ebe9a2567)

_Version 1.0.2, by Giorgio Bianchini_

**Description**: Propagates an attribute on the tree.

**Module type**: FurtherTransformation

**Module ID**: `85eee26d-29b6-4470-8184-f42ebe9a2567`

<br />

### [Prune node](ffc97742-4cf5-44ef-81aa-d5b51708a003)

_Version 1.2.0, by Giorgio Bianchini_

**Description**: Prunes nodes off the tree.

**Module type**: FurtherTransformation

**Module ID**: `ffc97742-4cf5-44ef-81aa-d5b51708a003`

<br />

### [Prune selection](f8abf1cd-d79f-403b-b0f2-4bb1412839ff)

_Version 1.0.4, by Giorgio Bianchini_

**Description**: Prunes the selected node off the tree.

**Module type**: SelectionAction

**Module ID**: `f8abf1cd-d79f-403b-b0f2-4bb1412839ff`

<br />

### [Radial](95b61284-b870-48b9-b51c-3276f7d89df1)

_Version 1.0.2, by Giorgio Bianchini_

**Description**: Computes the coordinates for a radial tree.

**Module type**: Coordinate

**Module ID**: `95b61284-b870-48b9-b51c-3276f7d89df1`

<br />

### [Rectangle](34e1a627-7b6a-4c0f-80d9-795eea245e1e)

_Version 1.0.1, by Giorgio Bianchini_

**Description**: Draws a rectangle on the plot.

**Module type**: Plotting

**Module ID**: `34e1a627-7b6a-4c0f-80d9-795eea245e1e`

<br />

### [Rectangular](68e25ec6-5911-4741-8547-317597e1b792)

_Version 1.0.2, by Giorgio Bianchini_

**Description**: Computes the coordinates for a rectangular tree.

**Module type**: Coordinate

**Module ID**: `68e25ec6-5911-4741-8547-317597e1b792`

<br />

### [Redo](8a2c7de0-58c5-4a85-9a0d-d11ce9844139)

_Version 1.0.0, by Giorgio Bianchini_

**Description**: Redoes an action.

**Module type**: MenuAction

**Module ID**: `8a2c7de0-58c5-4a85-9a0d-d11ce9844139`

<br />

### [Replace attribute](f17160ad-0462-449a-8a57-e1af775c92ba)

_Version 1.0.3, by Giorgio Bianchini_

**Description**: Changes the value of an attribute of a node that matches a criterion.

**Module type**: FurtherTransformation

**Module ID**: `f17160ad-0462-449a-8a57-e1af775c92ba`

<br />

### [Reroot tree](c6f96861-11c0-4853-9738-6a90cc81d660)

_Version 1.1.2, by Giorgio Bianchini_

**Description**: Re-roots the tree using the specified outgroup.

**Module type**: FurtherTransformation

**Module ID**: `c6f96861-11c0-4853-9738-6a90cc81d660`

<br />

### [Root tree on selection](77f387fb-c843-4164-aed2-bd5b8f325809)

_Version 1.1.2, by Giorgio Bianchini_

**Description**: Re-roots the tree using the selection as outgroup.

**Module type**: SelectionAction

**Module ID**: `77f387fb-c843-4164-aed2-bd5b8f325809`

<br />

### [Reshape tree](aaf3a3f5-d4d9-41c8-bd30-d99e061f28cf)

_Version 1.0.1, by Giorgio Bianchini_

**Description**: Changes the coordinate module and sets the plot actions to display the tree in a particular style.

**Module type**: Action

**Module ID**: `aaf3a3f5-d4d9-41c8-bd30-d99e061f28cf`

<br />

### [Resolve polytomy](45e08b70-0852-4141-ac67-8c8cd574926d)

_Version 1.0.0, by Giorgio Bianchini_

**Description**: Resolves a polytomy in the tree.

**Module type**: FurtherTransformation

**Module ID**: `45e08b70-0852-4141-ac67-8c8cd574926d`

<br />

### [RevBayes trace](89f05f57-dc57-4cc4-bace-84e52c201769)

_Version 1.0.0, by Giorgio Bianchini_

**Description**: Opens a tree trace file produced by RevBayes.
Safe even when opening huge files.

**Module type**: FileType

**Module ID**: `89f05f57-dc57-4cc4-bace-84e52c201769`

<br />

### [Rooted tree style](e56b8297-4417-4494-9369-cbe9e5d25397)

_Version 1.0.3, by Giorgio Bianchini_

**Description**: Sets the plot actions to display the tree as a rooted tree.

**Module type**: Action

**Module ID**: `e56b8297-4417-4494-9369-cbe9e5d25397`

<br />

### [Save tree](a8f25c08-4935-4fd5-80ea-1d29ada66f1e)

_Version 1.2.0, by Giorgio Bianchini_

**Description**: Saves the tree file.

**Module type**: MenuAction

**Module ID**: `a8f25c08-4935-4fd5-80ea-1d29ada66f1e`

<br />

### [Scale axis](aeacf625-90cf-41a5-8d10-c37c75aaa2b1)

_Version 1.1.0, by Giorgio Bianchini_

**Description**: Draws a scale axis.

**Module type**: Plotting

**Module ID**: `aeacf625-90cf-41a5-8d10-c37c75aaa2b1`

<br />

### [Scale bar](195bdabf-c5cf-4daf-992f-7a86a600beec)

_Version 1.0.0, by Giorgio Bianchini_

**Description**: Draws a scale bar.

**Module type**: Plotting

**Module ID**: `195bdabf-c5cf-4daf-992f-7a86a600beec`

<br />

### [Scale tree](d064aea6-6b43-4bd3-8cea-e72b4feb1142)

_Version 1.0.0, by Giorgio Bianchini_

**Description**: Scales all branch lengths in the tree by the specified factor.

**Module type**: FurtherTransformation

**Module ID**: `d064aea6-6b43-4bd3-8cea-e72b4feb1142`

<br />

### [Search](5f3a7147-f706-43dc-9f57-18ade0c7b15d)

_Version 1.0.3, by Giorgio Bianchini_

**Description**: Searches nodes in the tree.

**Module type**: Action

**Module ID**: `5f3a7147-f706-43dc-9f57-18ade0c7b15d`

<br />

### [Select root node](c0459ddc-8d6b-4614-bc8f-c824d63959f6)

_Version 1.0.0, by Giorgio Bianchini_

**Description**: Selects the root node of the tree.

**Module type**: MenuAction

**Module ID**: `c0459ddc-8d6b-4614-bc8f-c824d63959f6`

<br />

### [Set up age distributions](a1ccf05a-cf3c-4ca4-83be-af56f501c2a6)

_Version 1.0.2, by Giorgio Bianchini_

**Description**: Computes node age distributions.

**Module type**: FurtherTransformation

**Module ID**: `a1ccf05a-cf3c-4ca4-83be-af56f501c2a6`

<br />

### [Set up age distributions (attachment)](5d721496-f2fa-48de-ad0d-90ef5d8086aa)

_Version 1.2.0, by Giorgio Bianchini_

**Description**: Computes node age distributions from trees contained in an attachment.

**Module type**: FurtherTransformation

**Module ID**: `5d721496-f2fa-48de-ad0d-90ef5d8086aa`

<br />

### [Set up stochastic map](32858c9d-0247-497f-aeee-03f7bfe24158)

_Version 1.0.2, by Giorgio Bianchini_

**Description**: Parses the information from a stochastic mapping analysis.

**Module type**: FurtherTransformation

**Module ID**: `32858c9d-0247-497f-aeee-03f7bfe24158`

<br />

### [Set up stochastic map (attachment)](0e2f5255-2d34-474b-955d-b531ee5ba605)

_Version 1.0.2, by Giorgio Bianchini_

**Description**: Parses the information from a stochastic mapping analysis contained in an attachment.

**Module type**: FurtherTransformation

**Module ID**: `0e2f5255-2d34-474b-955d-b531ee5ba605`

<br />

### [Sort nodes](8a3e4e83-6c4d-45a8-8737-bff99accd176)

_Version 1.0.0, by Giorgio Bianchini_

**Description**: Sorts the nodes of the tree in ascending or descending order.

**Module type**: FurtherTransformation

**Module ID**: `8a3e4e83-6c4d-45a8-8737-bff99accd176`

<br />

### [Stochastic mapping branches](f7a20f2f-94b2-4331-8bbf-4e0087da6fba)

_Version 1.0.3, by Giorgio Bianchini_

**Description**: Plots branches with data from a stochastic mapping analysis.

**Module type**: Plotting

**Module ID**: `f7a20f2f-94b2-4331-8bbf-4e0087da6fba`

<br />

### [Stochastic map](e760952f-56c1-4192-8dfb-b5d6ec2692d2)

_Version 1.1.2, by Giorgio Bianchini_

**Description**: Opens a file containing one or more trees in the format produced by the write.simmap function of phytools (Revell 2012).
Safe even when opening huge files.

**Module type**: FileType

**Module ID**: `e760952f-56c1-4192-8dfb-b5d6ec2692d2`

<br />

### [Subsample tree](2b9a5563-4acf-49df-9cbc-46623975081e)

_Version 1.0.0, by Giorgio Bianchini_

**Description**: Removes taxa from the tree until only the requested number of taxa remain.

**Module type**: FurtherTransformation

**Module ID**: `2b9a5563-4acf-49df-9cbc-46623975081e`

<br />

### [Switch children](c4c71099-c7dc-44b3-93be-25a79afb1102)

_Version 1.0.0, by Giorgio Bianchini_

**Description**: Switches the order of the children of the node.

**Module type**: FurtherTransformation

**Module ID**: `c4c71099-c7dc-44b3-93be-25a79afb1102`

<br />

### [Switch selection](0b27abb2-0d48-40c0-9d1e-cfc7ffb7284c)

_Version 1.0.2, by Giorgio Bianchini_

**Description**: Switches the order of the children of the selection.

**Module type**: SelectionAction

**Module ID**: `0b27abb2-0d48-40c0-9d1e-cfc7ffb7284c`

<br />

### [Text element](ebafe997-c220-425a-ae39-06e731de1a07)

_Version 1.0.1, by Giorgio Bianchini_

**Description**: Draws a text element on the plot.

**Module type**: Plotting

**Module ID**: `ebafe997-c220-425a-ae39-06e731de1a07`

<br />

### [Transform lengths](f9241a42-c0cb-41a5-a1ee-a68fc339dee8)

_Version 1.0.0, by Giorgio Bianchini_

**Description**: Transforms all the branch lengths in the tree.

**Module type**: FurtherTransformation

**Module ID**: `f9241a42-c0cb-41a5-a1ee-a68fc339dee8`

<br />

### [Undo](24093e44-fdb0-427a-b00a-21f24fb95898)

_Version 1.0.0, by Giorgio Bianchini_

**Description**: Undoes the last action.

**Module type**: MenuAction

**Module ID**: `24093e44-fdb0-427a-b00a-21f24fb95898`

<br />

### [Unroot tree](f06dce2a-794b-4897-a154-82f7f44c125d)

_Version 1.0.0, by Giorgio Bianchini_

**Description**: Unroots the tree.

**Module type**: FurtherTransformation

**Module ID**: `f06dce2a-794b-4897-a154-82f7f44c125d`

<br />

### [Unrooted tree style](a99eb0c6-a69d-4785-961a-a0c247e9704d)

_Version 1.0.3, by Giorgio Bianchini_

**Description**: Sets the plot actions to display the tree as an unrooted tree.

**Module type**: Action

**Module ID**: `a99eb0c6-a69d-4785-961a-a0c247e9704d`

